From 157a7e0c716c9a5f0278f2af4b09a14a47cf5203 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Gustavo=20Henrique=20Milar=C3=A9?= <gugamilare@gmail.com>
Date: Thu, 12 Aug 2010 17:47:26 -0300
Subject: Simple optimizations for BINOMIAL-COEFFICIENT and COUNT-PERMUTATIONS

---
 numbers.lisp |   13 ++++++++-----
 1 files changed, 8 insertions(+), 5 deletions(-)

diff --git a/numbers.lisp b/numbers.lisp
index bf6ef0b..b260c78 100644
--- a/numbers.lisp
+++ b/numbers.lisp
@@ -210,6 +210,9 @@ greater then K."
   (if (or (zerop k) (= n k))
       1
       (let ((n-k (- n k)))
+        ;; Swaps K and N-K if K < N-K because the algorithm
+        ;; below is faster for bigger K and smaller N-K
+        (if (< k n-k) (rotatef k n-k))
         (if (= 1 n-k)
             n
             ;; General case, avoid computing the 1x...xK twice:
@@ -231,8 +234,8 @@ greater then K."
 
 (defun count-permutations (n &optional (k n))
   "Number of K element permutations for a sequence of N objects.
-R defaults to N"
-  ;; FIXME: Use %multiply-range and take care of 1 and 2, plus
-  ;; check types.
-  (/ (factorial n)
-     (factorial (- n k))))
+K defaults to N"
+  (check-type n (integer 0))
+  (check-type k (integer 0))
+  (assert (>= n k))
+  (%multiply-range (1+ (- n k)) n))
-- 
1.7.0.4

